#!/bin/bash
PID=$$
FIFO=/tmp/FIFO${PID}
mkfifo $FIFO
#############################################################################################

valider() {
echo "EXIT@SAVE"
} 


annuler() {
echo "EXIT@"
}


treeview_ep_trouves() {
echo "TREE@GET@treeview_ep_trouves"
echo "ITER@tri"
}

tri () {
episode="$treeview_ep_trouves"
if [ "$episode" != "|normal" ] ; then
	LISTE_RANGES_TMP=$(cat treeview_ep_ranges.data | grep -v  ^"|normal"$)
	if [ "$LISTE_RANGES_TMP" = "" ] ; then
		echo -e "$episode" >treeview_ep_ranges.data
	else
		echo -e "$LISTE_RANGES_TMP\n$episode" >treeview_ep_ranges.data
	fi
	LISTE_TROUVES_TMP=$(cat treeview_ep_trouves.data | grep -v "$episode" | grep -v  ^"|normal"$)
	if [ "$LISTE_TROUVES_TMP" = "" ] ; then
		echo "|normal" >treeview_ep_trouves.data
	else
		echo "$LISTE_TROUVES_TMP" >treeview_ep_trouves.data
	fi
	echo "TREE@LOAD@treeview_ep_trouves@treeview_ep_trouves.data"
	echo "TREE@LOAD@treeview_ep_ranges@treeview_ep_ranges.data"
fi
}


treeview_ep_ranges() {
echo "TREE@GET@treeview_ep_ranges"
echo "ITER@annule_tri"
}

annule_tri () {
episode="$treeview_ep_ranges"
if [ "$episode" != "|normal" ] ; then
	LISTE_TROUVES_TMP=$(cat treeview_ep_trouves.data | grep -v  ^"|normal"$)
	if [ "$LISTE_TROUVES_TMP" = "" ] ; then
		echo -e "$episode" >treeview_ep_trouves.data
	else
		echo -e "$LISTE_TROUVES_TMP\n$episode" >treeview_ep_trouves.data
	fi
	LISTE_RANGES_TMP=$(cat treeview_ep_ranges.data | grep -v "$episode" | grep -v  ^"|normal"$)
	if [ "$LISTE_RANGES_TMP" = "" ] ; then
		echo "|normal" >treeview_ep_ranges.data
	else
		echo "$LISTE_RANGES_TMP" >treeview_ep_ranges.data
	fi
	echo "TREE@LOAD@treeview_ep_trouves@treeview_ep_trouves.data"
	echo "TREE@LOAD@treeview_ep_ranges@treeview_ep_ranges.data"
fi
}


tous_transferer () {
LISTE_RANGES_TMP=$(cat treeview_ep_ranges.data | grep -v  ^"|normal"$)
if [ "$LISTE_RANGES_TMP" = "" ] ; then
	cat treeview_ep_trouves.data | grep -v  ^"|normal"$ >treeview_ep_ranges.data
else
	cat treeview_ep_trouves.data | grep -v  ^"|normal"$ >>treeview_ep_ranges.data
fi
echo "|normal" >treeview_ep_trouves.data
echo "TREE@LOAD@treeview_ep_trouves@treeview_ep_trouves.data"
echo "TREE@LOAD@treeview_ep_ranges@treeview_ep_ranges.data"
}


##########################################################################################
while read ligne; do
    if [[ "$ligne" =~ GET@ ]]; then
       eval ${ligne#*@}
       echo "DEBUG => in boucle bash :" ${ligne#*@}
    else
       echo "DEBUG=> in bash NOT GET" $ligne
       $ligne
   fi 
done < <(while true; do
    read entree < $FIFO
    [[ "$entree" == "QuitNow" ]] && break
     echo $entree   
done)
exit
